{$INCLUDE kmz.config.pas}

var
  num_images,s:integer;
  PI,Z:extended;
  zip:string;

function ExportExtension: string;
begin
  Result := 'KMZ';
end;


function ExportDescription: string;
begin
  Result := 'Garmin google maps (Osik)';
end;


function ExportHeader: string;
begin
  Result := '<?xml version="1.0" encoding="UTF-8"?>'+CRLF
  +'<kml xmlns="http://earth.google.com/kml/2.2">'+CRLF
  +'<folder>'+CRLF;
  ForceDirectories(GEOGET_DATADIR+'\files');
  PI:=3.1415926535897932384626433832795;
  Z:=256.0*Power(2,StrToInt(zoom)-1);
  zip:='';
  s:=640;
  num_images:=0;
end;


function ExportFooter: string;
begin
  Result := '</folder>'+CRLF
  +'</kml>'+CRLF;
end;


function OneMap(Lat,Lon,Name:string):string;
var
  http,jpg:string;
  West,East,North,South,Y:extended;
  a:string;
begin
  if(num_images<100) then begin
    http:='';
    jpg:=maptype+'_'+zoom+'_'+Lat+'_'+Lon+'_'+IntToStr(s)+'.jpg';
    a:='http://maps.google.com/maps/api/staticmap?center='+Lat+','+Lon+'&zoom='+zoom+'&size='+IntToStr(s)+'x'+IntToStr(s)+'&format=jpg-baseline&maptype='+maptype+'&sensor=false&key=ABQIAAAASAU1pgI4de_FJsrFBWipQBT2iSASnO5L5DwrXIyWzBZOX69JcRSrsAMPzSFnfq7-RwpQmySZzWpHjQ';
    if not FileExists(GEOGET_DATADIR+'\files\'+jpg) then begin
      GeoBusyCaption('Getting Google maps ...');
      HttpAsk('GET','','','',http);
      if HttpAsk('GET',a,'','',http) then
        StringToFile(http,GEOGET_DATADIR+'\files\'+jpg)
      else ShowMessage('Error: Cannot get map for '+Name+'.');
    end;
    if FileExists(GEOGET_DATADIR+'\files\'+jpg) then begin
      num_images:=num_images+1;
      StringToFile(FileToString(GEOGET_DATADIR+'\files\'+jpg),
        GEOGET_DATADIR+'\files\'+IntToStr(num_images)+'.jpg');
      zip:=zip+' files/'+IntToStr(num_images)+'.jpg';
      Y:=Z*arctanh(sin(StrToFl(Lat)*PI/180.0))/PI;
      West:=StrToFl(Lon)-180.0*s/2.0/Z;
      East:=West+180.0*s/Z;
      North:=arcsin(tanh(PI*(Y+s/2.0)/Z))*180.0/PI;
      South:=arcsin(tanh(PI*(Y-s/2.0)/Z))*180.0/PI;
      Result:='<GroundOverlay>'+CRLF
        +'<Icon>'+CRLF
        +'<href>files/'+IntToStr(num_images)+'.jpg</href>'+CRLF
        +'<viewBoundScale>0.75</viewBoundScale>'+CRLF
        +'</Icon>'+CRLF
        +'<LatLonBox>'+CRLF
        +ReplaceString(
          '<north>'+FormatFloat('#.000000',North)+'</north>'+CRLF
          +'<south>'+FormatFloat('#.000000',South)+'</south>'+CRLF
          +'<west>'+FormatFloat('#.000000',West)+'</west>'+CRLF
          +'<east>'+FormatFloat('#.000000',East)+'</east>'+CRLF
          ,',','.')
        +'</LatLonBox>'+CRLF
        +'</GroundOverlay>'+CRLF;
    end;
  end else if num_images=100 then begin
    ShowMessage('Warning: Due to Garmin limitation'+CRLF+'only first 100 maps can be exported.');
    GeoBusyCaption('Skipping...');
    num_images:=101;
  end;
end;


function ExportPoint: string;
begin
  GeoBusyKind(GC.Name);
  Result:=OneMap(GC.CorrectedLat,GC.CorrectedLon,GC.Name);
end;


function ExportAfter(file:string): string;
begin
  DeleteFile(GEOGET_DATADIR+'\doc.kml');
  RenameFile(file,GEOGET_DATADIR+'\doc.kml');
  RunExec('7za.exe a -tzip -mx=0 "'+file+'" doc.kml'+zip);
end;
